// Copyright 2024 schukai GmbH
// SPDX-License-Identifier: proprietary

package pathfinder

import (
	"github.com/stretchr/testify/assert"
	"testing"
)

type DeepNestedStruct struct {
	A PathValue
}

type MyStruct struct {
	I map[string]DeepNestedStruct
}

func TestReplacePath(t *testing.T) {
	// Sample seed data to guide the fuzzer

	s := &MyStruct{
		I: map[string]DeepNestedStruct{
			"key1GI": {
				A: "rel/pathGIA",
			},
		},
	}

	err := SetValue[*MyStruct](s, "I.key1GI.A", "new/pathGIA")
	assert.Nil(t, err)

	assert.Equal(t, PathValue("new/pathGIA"), s.I["key1GI"].A)

}
